option explicit
option default float

' 3D wire frame graphics demo using quaternions to rotate the coordinates
dim rotq(4),v(4),vout(4),i%,x1,y1,z1,x2,y2,z2,mag,vertex
' define the coordinates of a cube with the z-axis towards the viewer
' coordinates of the cube
dim cube(3,7)
for i%=0 to 7
  'reads the cube vertex
  read x1
  read y1
  read z1
  read mag
  'convert coordinates to normalised form
  math q_vector x1,y1,z1,v()
  cube(0,i%)=v(1)
  cube(1,i%)=v(2)
  cube(2,i%)=v(3)
  cube(3,i%)=v(4)
next
'actual location of the centre of the cube in space
dim cubelocation(2)=(mm.hres/2,mm.vres/2,-500)
'define the coordinate pairs that make up the edges of the cube
dim cubelines%(1,11)
for i%=0 to 11
  read cubelines%(0,i%) 'read first  line side vertex
  read cubelines%(1,i%) 'read second line side vertex
next
'define the projection plane
dim viewplane = -200
dim lines%(3,11) 'storage for the coordinates for lines drawn
'create a quarternion to rotate 2 degrees about x axis
'play with the x,y,z vector which is the sxis of rotation
math q_create rad(2), 1,0,0, rotq()
'draw lines in memory (page 1)
page write 1
do
  cls
  for i%=0 to 11 'project the coordinates onto the viewplane
    vertex=cubelines%(0,i%)
    z1=cube(2,vertex)*cube(3,vertex)+cubelocation(2)
    x1=(cube(0,vertex)*cube(3,vertex)*viewplane/z1+cubelocation(0))
    y1=(cube(1,vertex)*cube(3,vertex)*viewplane/z1+cubelocation(1))

    vertex=cubelines%(1,i%)
    z2=cube(2,vertex)*cube(3,vertex)+cubelocation(2)
    x2=(cube(0,vertex)*cube(3,vertex)*viewplane/z2+cubelocation(0))
    y2=(cube(1,vertex)*cube(3,vertex)*viewplane/z2+cubelocation(1))

    lines%(0,i%)=x1 : lines%(1,i%)=y1
    lines%(2,i%)=x2 : lines%(3,i%)=y2
  next i%
  for i%=0 to 7 'rotate coordinates
    v(1)=cube(0,i%) 'X
    v(2)=cube(1,i%) 'Y
    v(3)=cube(2,i%) 'X
    v(0)=cube(3,i%) 'magnitude
    v(4)=0
    math q_rotate rotq(),v(),vout()
    cube(0,i%)=vout(1) 'X
    cube(1,i%)=vout(2) 'Y
    cube(2,i%)=vout(3) 'Z
    cube(3,i%)=vout(0) 'magnitude
  next i%
  
  for i%=0 to 11 'draw the new lines
    line lines%(0,i%),lines%(1,i%),lines%(2,i%),lines%(3,i%),1,rgb(white)
  next i%
  'copy page 1 to the screen (page 0)
  page copy 1 to 0
loop

end

' Cube vertices coordinates
data -100,-100, 100,0, -100,100, 100,0
data  100,-100, 100,0,  100,100, 100,0
data -100,-100,-100,0, -100,100,-100,0
data  100,-100,-100,0,  100,100,-100,0
' Cube lines vertices
data 0,1, 0,2, 1,3, 2,3
data 4,5, 4,6, 5,7, 6,7
data 0,4, 1,5, 2,6, 3,7

